<template>
  <div class="container-fluid mt-5">
    <div class="row justify-content-center">
      <div class="col-md-4">
        <div class="card border-0 shadow rounded">
          <div class="card-body text-left">
            <h4 class="text-center font-weight-bold">Register</h4>
            <form @submit.prevent="register">
              <!-- full name -->
              <div class="form-group">
                <label>Full Name</label>
                <input type="text" v-model="user.name" class="form-control" />
              </div>
              <div v-if="validation.name" class="mb-2" style="color: red;">
                <strong>{{ validation.name[0] }}</strong>
              </div>

              <!-- email address -->
              <div class="form-group">
                <label>Email Address</label>
                <input type="email" v-model="user.email" class="form-control" />
              </div>
              <div v-if="validation.email" class="mb-2" style="color: red;">
                <strong>{{ validation.email[0] }}</strong>
              </div>

              <!-- password -->
              <div class="form-group">
                <label>Password</label>
                <input type="password" v-model="user.password" class="form-control" />
              </div>
              <div v-if="validation.password" class="mb-2" style="color: red;">
                <strong>{{ validation.password[0] }}</strong>
              </div>

              <!-- confirm password -->
              <div class="form-group">
                <label>Confirm Password</label>
                <input type="password" v-model="user.password_confirmation" class="form-control" />
              </div>

              <!-- button submit -->
              <button type="submit" class="btn btn-primary btn-block border-0">
                Register
              </button>
            </form>
          </div>
        </div>
        <div class="register mt-3 text-center">
          <p>
            Already have an account?
            <router-link :to="{ name: 'login' }">Login</router-link>
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { ref, reactive } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

export default {
  name: "RegisterComponent",

  setup() {
    // user state
    const user = reactive({
      name: "",
      email: "",
      password: "",
      password_confirmation: "",
    });

    // validation state
    const validation = ref([]);

    //store vuex
    const store = useStore();

    //route
    const router = useRouter();

    //function register, fungsi ini di jalankan ketika form di submit
    function register() {
      //define variable
      let name = user.name;
      let email = user.email;
      let password = user.password;
      let password_confirmation = user.password_confirmation;

      //panggil action "register" di dalam module "auth" vuex
      store.dispatch("auth/register", {
        name,
        email,
        password,
        password_confirmation,
      })
        .then(() => {
          //redirect ke dashboard
          router.push({ name: "dashboard" });
        })
        .catch((error) => {
          //show validaation message
          validation.value = error;
        });

    }

    // return a state and function
    return {
      user,
      validation,
      register,
    };
  },
};
</script>
